unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Character,
  system.Diagnostics;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    ClearBtn: TBitBtn;
    LabeledEdit2: TLabeledEdit;
    GroupBox2: TGroupBox;
    RadioGroup2: TRadioGroup;
    BitBtn2: TBitBtn;
    LabeledEdit3: TLabeledEdit;
    GroupBox3: TGroupBox;
    RadioGroup3: TRadioGroup;
    BitBtn3: TBitBtn;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    GroupBox4: TGroupBox;
    RadioGroup4: TRadioGroup;
    BitBtn4: TBitBtn;
    LabeledEdit6: TLabeledEdit;
    GroupBox5: TGroupBox;
    RadioGroup5: TRadioGroup;
    BitBtn5: TBitBtn;
    LabeledEdit7: TLabeledEdit;
    CheckBox1: TCheckBox;
    Edit1: TEdit;
    CheckBox2: TCheckBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
  private
    { Private 錾 }
    procedure degrees15steps;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Big_Math, Velthuis.Bigdecimals, Velthuis.bigintegers;

// L
function InPrecision(s: string; m: integer): integer;
var
  ch : integer;
begin
  val(s, Result, ch);
  if ch <> 0 then begin
    application.MessageBox('LɊԈႢ܂B','',0);
    result := -1;
    exit;
  end;
  if Result < 1 then begin
    application.MessageBox('L͂PȏɂĂB','',0);
  end;
  if m = 0 then begin
    if Result >2500 then begin
      application.MessageBox('L2500ɂĂB','',0);
      result := -1;
    end;
  end
  else
    if Result > 50000 then begin
      application.MessageBox('L50000ɂĂB','',0);
      result := -1;
    end;
end;

// w̖ꍇ̐lmF
// x:  'e','E'̂Ȃ
// ca:  0 '.' ꍇ@1 Ȃꍇ
// 肪ꍇ 0Ԃ܂
function numeralfloatcheck(x: string; ca: byte): integer;
var
  len, dn, n, d : integer;
  num, numb : string;
  flg : boolean;
  snum : integer;
begin
  len := length(x);                   // 
  snum := 1;
  num := x[1];                        // P
  dn := 0;
  flg := true;
  if num = '+' then inc(snum);          // '+' pX
  if num = '-' then inc(snum);          // '-' pX
  if num = '.' then begin               // '.'
    inc(dn);                            // '.'JEgCNg
    inc(snum);                          // pX
  end;
  for n := snum to len do begin       // snum len lmF
    num := x[n];
    if num = '.' then begin             // '.'
      inc(dn);                          // '.'JEgCNg
      continue;                         // pX
    end;
    flg := false;
    for d := 0 to 9 do begin            // 0`9̒lmF
      numb := inttostr(d);
      if numb = num then begin
        flg := true;
        break;
      end;
    end;
    if flg = false then break;
  end;
  if ca = 0 then begin                // '.'
    if dn > 1 then flg := false;        // '.'1Ȃ0k
  end
  else                                // '.'
    if dn > 0 then flg := false;        // '.'MG

  if flg then result := 0
         else result := 1;
end;

// ͊mF
function incheck(s, m: string): boolean;
const
  ec = 'e';
  eo = 'E';
  dt = '.';
var
  fs, es : string;
  ch, p, po, leng : integer;
begin
  result := false;
  p := pos(ec, s);             // 'e' ̈ʒu
  po := pos(eo, s);            // 'E' ̈ʒu
  p := p + po;
  if p = 0 then begin          // 'e'  'E' 
    ch := numeralfloatcheck(s, 0);    // '.'ŊmFĂǂ
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
    result := true;
    exit;
  end;
  leng := length(s);
  fs := '';
  fs := copy(s, 1, p - 1);            // 'e'̑O̕o
  es := '';
  es := copy(s, p + 1, leng - p);     // 'e'̌̕o
  ch := numeralfloatcheck(fs, 0);     // 'e'̑O̊̕mF '.'ŊmFĂǂ
  if ch <> 0 then begin
    application.MessageBox(' ͒lɊԈႢ܂B','',0);
    exit;
  end;
  if es <> '' then begin              // 'e'̌̕mF
    ch := numeralfloatcheck(es, 1);   // '.'ŊmF
    if ch <> 0 then begin
      application.MessageBox(' ͒lɊԈႢ܂B','',0);
      exit;
    end;
  end;
  result := true;
end;

// 15Ԋusin,cos,tan
// sin,cos,taňvZlmFp
procedure TForm1.degrees15steps;
var
  zero, one, two, three, fore, six, ans : bigdecimal;
  deg, m, dpcs, dpcs2 : integer;
begin
  dpcs := bigdecimal.DefaultPrecision;
  dpcs2 := dpcs * 2;
  zero  := '0';
  one   := '1';
  two   := '2';
  three := '3';
  fore  := '4';
  six   := '6';
  // sin
  if Radiogroup1.ItemIndex = 0 then
    for m := 0 to 6 do begin
      deg := m * 15;
      case m of
        0 : ans := zero;
        1 : ans := (Bigdecimal.Sqrt(six, dpcs2) - Bigdecimal.Sqrt(two, dpcs2)) / fore;
        2 : ans := one / two;
        3 : ans := Bigdecimal.Sqrt(two, dpcs2) / two;
        4 : ans := Bigdecimal.Sqrt(three, dpcs2) / two;
        5 : ans := (Bigdecimal.Sqrt(six, dpcs2) + Bigdecimal.Sqrt(two, dpcs2)) / fore;
        6 : ans := one;
      end;
      memo1.Lines.Append('sin' + inttostr(deg) + ' = ' + ans.ToPlainString);
    end;
  // cos
  if Radiogroup1.ItemIndex = 1 then
    for m := 0 to 6 do begin
      deg := m * 15;
      case m of
        0 : ans := one;
        1 : ans := (Bigdecimal.Sqrt(six, dpcs2) + Bigdecimal.Sqrt(two, dpcs2)) / fore;
        2 : ans := Bigdecimal.Sqrt(three, dpcs2) / two;
        3 : ans := Bigdecimal.Sqrt(two, dpcs2) / two;
        4 : ans := one / two;
        5 : ans := (Bigdecimal.Sqrt(six, dpcs2) - Bigdecimal.Sqrt(two, dpcs2)) / fore;
        6 : ans := zero;
      end;
      memo1.Lines.Append('cos' + inttostr(deg) + ' = ' + ans.ToPlainString);
    end;
  // tan
  if Radiogroup1.ItemIndex = 2 then
    for m := 0 to 6 do begin
      deg := m * 15;
      case m of
        0 : ans := zero;
        1 : ans := two - Bigdecimal.Sqrt(three, dpcs2);
        2 : begin
              ans := Bigdecimal.Sqrt(three, dpcs2) / three;
              ans := ans.RoundToPrecision(dpcs);
            end;
        3 : ans := one;
        4 : ans := Bigdecimal.Sqrt(three, dpcs2);
        5 : ans := two + Bigdecimal.Sqrt(three, dpcs2);
      end;
      if m = 6 then
        memo1.Lines.Append('tan' + inttostr(deg) + ' = ' + 'undefined')
      else
        memo1.Lines.Append('tan' + inttostr(deg) + ' = ' + ans.ToPlainString);
    end;
end;

// sin(x),cos(x),tan(x)
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  Precision : integer;
  x, y, deg : bigdecimal;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(LabeledEdit1.Text, 'px') then exit;
  Precision := InPrecision(LabeledEdit2.Text, 0);   // L
  if Precision < 1 then exit;
  BigDecimal.DefaultPrecision := Precision;
  if checkbox2.Checked then begin
    degrees15steps;
    exit;
  end;
  deg := LabeledEdit1.Text;
  if deg > 720 then begin
    application.MessageBox(' px720ȉɂĉB','',0);
    exit;
  end;
  StopWatch := TStopwatch.StartNew;
  x := degtorad(deg);
  case Radiogroup1.ItemIndex of
    0 : y := sin_big(x);
    1 : y := cos_big(x);
    2 : y := tan_big(x);
  end;
  memo1.Lines.Append(y.ToPlainString);
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

// arcsin(x),arccos(x),arctan(x),arctan2(y,x);
procedure TForm1.BitBtn2Click(Sender: TObject);
var
  xi, yi, x, one, ans, y : bigdecimal;
  zero : bigDecimal;
  Precision : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(LabeledEdit3.Text, 'x') then exit;
  Precision := InPrecision(LabeledEdit2.Text, 0);                     // L
  if Precision < 1 then exit;
  StopWatch := TStopwatch.StartNew;
  BigDecimal.DefaultPrecision := Precision;
  zero := '0';
  one := '1';
  xi := LabeledEdit3.Text;
  x := BigDecimal.Abs(xi);
  case Radiogroup2.ItemIndex of
    0: begin
          if x > one then begin
            application.MessageBox('x̓͒l傫܂B','',0);
            exit;
          end;
          if checkbox1.Checked = false then
            y := arcsin_big(xi)
          else
            y := arcsina_big(xi);
       end;
    1: begin
          if x > one then begin
            application.MessageBox('x̓͒l傫܂B','',0);
            exit;
          end;
          if checkbox1.Checked = false then
            y := arccos_big(xi)
          else
            y := arccosa_big(xi);
       end;
    2: begin
          if checkbox1.Checked = false then
            y := arctan_big(xi)
          else
            y := arctana_big(xi);
       end;
    3: begin
          if not incheck(LabeledEdit4.Text, 'y') then exit;
          yi := LabeledEdit4.Text;
          if checkbox1.Checked = false then
            y := arctan2_big(yi, xi)
          else
            y := arctan2a_big(yi, xi);
       end;
    4: begin
          if xi < zero then begin
            application.MessageBox('x[傫ĉB','',0);
            exit;
          end;
          if not incheck(LabeledEdit4.Text, 'y') then exit;
          yi := LabeledEdit4.Text;
          y := power_big(xi, yi);
          memo1.Lines.Append(y.ToString);
          exit;
       end;
  end;
  ans := radTodeg(y);
  memo1.Lines.Append(ans.ToPlainString);
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

// log(x),e^(x),
procedure TForm1.BitBtn3Click(Sender: TObject);
var
  x, y: bigdecimal;
  Precision : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  case Radiogroup3.ItemIndex of
    0, 1: begin
            if not incheck(LabeledEdit5.Text, 'x') then exit;
            x := LabeledEdit5.Text;
          end;
  end;
  if Radiogroup3.ItemIndex <> 2 then
    Precision := InPrecision(LabeledEdit2.Text, 0) // L
  else
    Precision := InPrecision(LabeledEdit2.Text, 1); // L
  if Precision < 1 then exit;
  StopWatch := TStopwatch.StartNew;
  BigDecimal.DefaultPrecision := Precision;
  case Radiogroup3.ItemIndex of
    0: begin
          y := log_big(x);
          memo1.Lines.Append(y.ToPlainString);
       end;
    1: begin
          y := exp_big(x);
          memo1.Lines.Append(y.ToString);
       end;
    2: begin
          y := pi_big;
          y := y.RoundToPrecision(Precision);
          memo1.Lines.Append(y.ToString);
       end;
  end;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

// sinh(x),cosh(x),tanh(x)
procedure TForm1.BitBtn4Click(Sender: TObject);
var
  x, y : bigdecimal;
  Precision : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(LabeledEdit6.Text, 'x') then exit;
  Precision := InPrecision(LabeledEdit2.Text, 0);                     // L
  if Precision < 1 then exit;
  StopWatch := TStopwatch.StartNew;
  x := LabeledEdit6.Text;
  BigDecimal.DefaultPrecision := Precision;
  case Radiogroup4.ItemIndex of
    0: y := sinh_big(x);
    1: y := cosh_big(x);
    2: y := tanh_big(x);
  end;
  memo1.Lines.Append(y.ToPlainString);
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

// arsinh(x),arcosh(x),artanh(x)
procedure TForm1.BitBtn5Click(Sender: TObject);
var
  x, y, one : bigdecimal;
  Precision : integer;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
begin
  if not incheck(LabeledEdit7.Text, 'x') then exit;
  Precision := InPrecision(LabeledEdit2.Text, 0);                     // L
  if Precision < 1 then exit;
  StopWatch := TStopwatch.StartNew;
  BigDecimal.DefaultPrecision := Precision;
  one := '1';
  x := LabeledEdit7.Text;
  case Radiogroup5.ItemIndex of
    0:  y := arsinh_big(x);
    1:  begin
          if x < one then begin
            application.MessageBox('x̓͒lPȏɂĉB','',0);
            exit;
          end;
          y := arcosh_big(x);
        end;
    2:  begin
          if x >= one then begin
            application.MessageBox('x̓͒lPȉɂĉB','',0);
            exit;
          end;
          y := artanh_big(x);
        end;
  end;
  memo1.Lines.Append(y.ToPlainString);
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;
  Edit1.text := 'Z = ' + intTostr(ElapsedMillseconds) + 'msec';
end;

procedure TForm1.ClearBtnClick(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  memo1.Clear;
end;

end.
