// pi_big͈ꖜłok@̑1000xł𒴂ƁAZɒxȂ܂B
// L100xłΖ肠܂B
// pi_bigȊO2500ʂłAȏKvȏꍇ͎[v̏ݒOĉB

// 64rbgŃRpCȂƉZxȂ܂B

unit Big_Math;


interface

uses Velthuis.Bigdecimals, System.SysUtils, Vcl.Forms, Velthuis.BigIntegers;
//uses Velthuis.Bigdecimals, System.SysUtils, Vcl.Forms, Velthuis.BigIntegers, main;

function pi_big: Bigdecimal;
function sin_big(x: bigdecimal): bigDecimal;
function cos_big(x: bigdecimal): bigdecimal;
function tan_big(x: bigdecimal): bigdecimal;
function arcsin_big(z: bigdecimal): bigdecimal;
function arcsina_big(xi: bigdecimal): bigdecimal;
function arccos_big(z: bigdecimal): bigdecimal;
function arccosa_big(xi: bigdecimal): bigdecimal;
function arctan_big(z: bigdecimal): bigdecimal;
function arctana_big(xi: bigdecimal): bigdecimal;
function log_big(xi: bigdecimal): bigdecimal;
function exp_big(x: bigDecimal): bigdecimal;
function arctan2_big(yi, xi: bigdecimal): bigdecimal;
function arctan2a_big(yi, xi: bigdecimal): bigdecimal;
function sinh_Big(x: bigdecimal): bigdecimal;
function cosh_big(x: bigdecimal): bigdecimal;
function tanh_big(x: bigdecimal): bigdecimal;
function arsinh_big(z: bigdecimal): bigdecimal;
function arcosh_big(z: bigdecimal): bigdecimal;
function artanh_big(z: bigdecimal): bigdecimal;
function power_big(xi, yi: bigdecimal): bigdecimal;
function degTorad(deg: bigdecimal): bigdecimal;
function radTodeg(rad: bigdecimal): bigdecimal;
function BigdecimalToDouble(b: bigdecimal): double;

implementation

// https://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html
// T.Ooura AGM ASY
function pi_big: Bigdecimal;
var
  n, dpcs, pcsBack : integer;
  rmback : BigDecimal.RoundingMode;
  SQRT_SQRT_EPSILON, c, b, e : BigDecimal;
  npow : Bigdecimal;
  a, one, two, four, five, eight : Bigdecimal;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                   // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  one := '1';
  one := one.RoundToPrecision(dpcs);                  // one̗Ldpcsɐݒ
  two := '2';
  four := '4';
  five := '5';
  eight := '8';
  SQRT_SQRT_EPSILON := one / BigDecimal.IntPower(two, dpcs shl 0); // l
  c := BigDecimal.Sqrt(one / eight, dpcs * 2);
  a := one + c + c + c;
  b := BigDecimal.Sqrt(a, dpcs * 2);
  e := b - five / eight;
  b := b + b;
  c := e - c;
  a := a + e;
  npow := '4';
  n := 0;
  while (e > SQRT_SQRT_EPSILON) and (n < 100) do begin
    npow := npow + npow;
    e := (a + b) / two;                               // ϒl ZLł̊ۂ
    b := a * b;
    b := b.RoundToPrecision(dpcs);                    // pcs +  ۂ
    b := BigDecimal.Sqrt(b, dpcs * 2);                // Lł̊ۂ
    e := e - b;
    b := b + b;
    c := c - e;
    a := e + b;
    inc(n);
  end;
  e := e * e;
  e := e.RoundToPrecision(dpcs);                      // pcs +  ۂ
  e := e / four;                                      // e = e * e / 4
  a := a + b;
  result := (a * a - e - e / two) / (a * c - e) / npow;   // Z̏Ԃɒ
  result := result.RoundToPrecision(dpcs);             // w̐xɊۂ

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// degPʂradɕϊ
function degTorad(deg: bigdecimal): bigdecimal;
var
  pib, tmp, d180 : bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  D180 := '180';
  tmp := deg * pib;
  tmp := tmp.RoundToPrecision(dpcs);
  result := tmp / D180;

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// radPʂdegɕϊ
function radTodeg(rad: bigdecimal): bigdecimal;
var
  pib, tmp, d180 : bigdecimal;
  dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  dpcs := BigDecimal.DefaultPrecision + 5;            // Zx
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  D180 := '180';
  tmp := rad * D180;
  tmp := tmp.RoundToPrecision(dpcs);
  result := tmp / pib;

  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// sin(x) s
// }N[WJ
// x px rad   dpcs L@
function sin_bigf(x : BigDecimal; dpcs : integer): BigDecimal;
var
  v, d, sq, u, k, two, one : BigDecimal;
  c : integer;
begin
  x := x.RoundToPrecision(dpcs);
  one := '1';
  Two := '2';
  d := x;
  sq := x * x;                                        // sq͏_ȉ dpcs * 2 
  sq := sq.RoundToPrecision(dpcs);                    // Ldpcs
  u := d;
  k := 0;
  c := 0;
  repeat
    k := k + Two;
    v := u;
    d := -d * sq;                               // _ȉ dpcs~2 
    d := d.RoundToPrecision(dpcs);              // Ldpcs Ɋۂ߂ȂƎ̏Zs͏_ȉ
    d := d / (k * (k + one));                   // ZŗLdpcs ZDefaultl
    u := v + d;
    u := u.RoundToPrecision(dpcs);              // Ldpcs ۂ ̈
    inc(c);
  until (v = u) or (c > 10000);
  v := v.RoundToPrecision(dpcs);                // Ldpcs
  result := v;
end;

// sin(x)vZ BigDecimal
// }N[WJ
function sin_big(x : BigDecimal): BigDecimal;
var
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  result := sin_bigf(x, dpcs);
  result := result.RoundToScale(pcsBack, rmNearesteven);  // LpcsBack
//  result := result.RoundToPrecision(pcsBack);         // LpcsBack

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// cos
// }N[WJ
// x (rad)  dpcs L
function cos_bigf(x: bigdecimal; dpcs: integer): bigdecimal;
var
  d, s, e, i, two, one, im: bigdecimal;
  k    : integer;
begin
  x := x.RoundToPrecision(dpcs);
  one := '1';
  two := '2';
  e := '1';
  s := '1';
  i := '1';
  x := x * x;
  x := x.RoundToPrecision(dpcs);              // Ldpcs
  k := 0;
  repeat
    d := s;
    e := e.Negate(e);
    e := e * x;
    im := i + one;
    im := im * i;
    im := im.RoundToPrecision(dpcs);
    e := e / im;
    s := s + e;
    s := s.RoundToPrecision(dpcs);            // Ldpcs ̈
    i := i + two;
    inc(k);
  until (s = d) or (k > 10000);
  s := s.RoundToPrecision(dpcs);              // Ldpcs
  result := s;
end;

// cos
// x (rad)
function cos_big(x: bigdecimal): bigdecimal;
var
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmdown;
  result := cos_bigf(x, dpcs);
  result := result.RoundToScale(pcsBack, rmdown);     // LpcsBack
//  result := Result.RoundToPrecision(pcsBack);

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// tan(x) = sin(x) / cos(x)
function tan_big(x: bigdecimal): bigdecimal;
label
  EXT;
var
  pib, pis2, one, two, s, c, t, zero, xb: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  zero := '0';
  one := '1';
  two := '2';
  pis2 := pib / Two;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  x := x.RoundToPrecision(dpcs);
  xb := x;
  // 0
  repeat                                              // 0`΂͈̔͂ɏC
    if x < 0 then x := x + pib;
    if x >= pib then x := x - pib;
  until (x < pib) and (x >= 0);
  s := pis2 - x;
  if pcsback > 3 then
    s := s.RoundToScale(pcsback - 2, rmdown);
  if s = zero then begin
    application.MessageBox('tan_big(x) ꂪ(0)ȒlłB','');
    result := '0';
    goto EXT;
  end;

  s := sin_bigf(xb, dpcs);
  c := cos_bigf(xb, dpcs);
  t := s / c;
  t := t.RoundToPrecision(pcsBack);                   // LpcsBack
  result := t;
EXT:
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// sinh
// x
function sinh_big(x: bigdecimal): bigdecimal;
var
  v, d, sq, u, k, one, two :bigdecimal;
  i             : integer;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  x := x.RoundToPrecision(dpcs);
  one := '1';
  two := '2';
  d := x;
  sq := x * x;
  sq := sq.RoundToPrecision(dpcs);
  u := d;
  k := '0';
  i := 1;
  repeat
    v := u;
    k := k + two;
    d := d * (sq / k / (k + one));
    d := d.RoundToPrecision(dpcs);
    u := v + d;
    u := u.RoundToPrecision(dpcs);
    inc(i)
  until (v = u) or (i > 10000);
  v := v.RoundToPrecision(pcsBack);                   // LpcsBack
  result := v;

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// cosh
// x
function cosh_big(x: bigdecimal): bigdecimal;
var
  d, s, e, k, one, two : bigdecimal;
  i    : integer;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  x := x.RoundToPrecision(dpcs);
  one := '1';
  two := '2';
  e := one;
  s := one;
  k := one;
  i := 0;
  repeat
    d := s;
    e := e * x * x;
    e := e.RoundToPrecision(dpcs);
    e := e / (k * (k + one));
    s := s + e;
    s := s.RoundToPrecision(dpcs);
    k := k + two;
    inc(i);
  until (s = d) or (i > 10000);
  s := s.RoundToPrecision(pcsBack);                   // LpcsBack
  result := s;

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// tanh
// x
function tanh_big(x: bigdecimal): bigdecimal;
var
  v, d, sq, u, k, one, two :bigdecimal;
  s, e: bigdecimal;
  i             : integer;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  x := x.RoundToPrecision(dpcs);
  one := '1';
  two := '2';
  d := x;
  sq := x * x;
  sq := sq.RoundToPrecision(dpcs);
  u := d;
  k := '0';
  i := 1;
  repeat
    v := u;
    k := k + two;
    d := d * (sq / k / (k + one));
    d := d.RoundToPrecision(dpcs);
    u := v + d;
    u := u.RoundToPrecision(dpcs);
    inc(i)
  until (v = u) or (i > 10000);
  e := one;
  s := one;
  k := one;
  i := 0;
  repeat
    d := s;
    e := e * x * x;
    e := e.RoundToPrecision(dpcs);
    e := e / (k * (k + one));
    s := s + e;
    s := s.RoundToPrecision(dpcs);
    k := k + two;
    inc(i);
  until (s = d) or (i > 10000);
  result := v / s;
  result := result.RoundToPrecision(pcsBack);               // LpcsBack

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// J[\̑ȉ~ϕ RC
//
// ---------------- RC ---------------------------------------------------------
function RC(x, y: bigdecimal): bigdecimal;
label
  Ext;
//const
//  r  = 1E-24;
//  Qc = 872;           // power(3 * r, -1 / 8) = 871.68554
//  c1 = 3 / 10;
//  c2 = 1 / 7;
//  c3 = 3 / 8;
//  c4 = 9 / 22;
//  c5 = 159 / 208;
//  c6 = 9 / 8;
var
  xt, yt, w, yb, zero : bigdecimal;
  lamda, A0, Q, dp : bigdecimal;
  s, Am, Qm     : bigdecimal;
  c, c1, c2, c3, c4, c5, c6, Qc : bigdecimal;
  m, dpcs, dpcm : integer;
  d1, d2, d3, d4, d7, d8, d9, d10, d22, d159, d208: bigdecimal;
begin
  dpcs := BigDecimal.DefaultPrecision;
  dpcm := dpcs + 5;
  BigDecimal.DefaultPrecision := dpcm;
  dp := '1E-' + intTostr(round(dpcm / 6));
  zero := '0';
  if y = zero then begin
    result := zero;
    goto Ext;
  end;
  d1 := '1';
  d2 := '2';
  d3 := '3';
  d4 := '4';
  d7 := '7';
  d8 := '8';
  d9 := '9';
  d10 := '10';
  d22 := '22';
  d159 := '159';
  d208 := '208';
  c1 := d3 / d10;
  c2 := d1 / d7;
  c3 := d3 / d8;
  c4 := d9 / d22;
  c5 := d159 / d208;
  c6 := d9 / d8;
  Qc := d1 / dp;
  if y > zero then begin
    xt := x;
    yt := y;
    w  := d1;
  end
  else begin
    xt := x - y;
    yt := - y;
    w := bigdecimal.sqrt(x / xt, dpcm * 2);     // sqrt ͗L1/2
  end;
  yb := yt;
  A0 := (xt + yt + yt) / d3;
  Am := A0;
  Q := Qc * bigdecimal.abs(A0 - xt);
//  Q := power(3 * r, -1 / 8) * abs(A0 - xt);
  m := 0;
  Qm := d1;
  repeat
    lamda := d2 * bigdecimal.sqrt(xt, dpcm * 2) * bigdecimal.sqrt(yt, dpcm * 2) + yt;   // sqrt ͗L1/2
    lamda := lamda.RoundToPrecision(dpcm);
    xt := (xt + lamda) / d4;
    yt := (yt + lamda) / d4;
    Am := (Am + lamda) / d4;
    m := m + 1;
    Qm := Qm / d4;
  until (Qm * Q < bigdecimal.abs(Am)) or (m > 10000);
  s := (yb - A0) * (Qm / Am);
  c5 := c5 + s * c6;
  c5 := c5.RoundToPrecision(dpcm);
  c4 := c4 + s * c5;
  c4 := c4.RoundToPrecision(dpcm);
  c3 := c3 + s * c4;
  c3 := c3.RoundToPrecision(dpcm);
  c2 := c2 + s * c3;
  c2 := c2.RoundToPrecision(dpcm);
  c1 := c1 + s * c2;
  c1 := c1.RoundToPrecision(dpcm);
  c := c1 * s * s + d1;
  c := c.RoundToPrecision(dpcm);
  Am := bigdecimal.sqrt(Am, dpcm * 2);           // sqrt ͗L1/2
  result := w * (c / Am);
  result := result.RoundToPrecision(dpcs);

//  s := (yb - A0) / power(4, m) / Am;
//  result := w * (d1 + s * s * (c1 + s * (c2 + s * (c3 + s * (c4 + s * (c5 + s * c6)))))) / bigdecimal.sqrt(Am);

Ext:
  BigDecimal.DefaultPrecision := dpcs;
end;

// arcsin
// 0.7𒴂甽Α̊px߂܂(arccosvZɂȂ܂)
// arcsin(x) = /2 - arccos(x)
function arcsina_big(xi: bigdecimal): bigdecimal;
label
  EXT;
var
  i : integer;
  pib, ans, bans, fa, fb, d, ab, ta, tb, f, x, seven, zero, one, two, ax: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  xi := xi.RoundToPrecision(dpcs);
  zero := '0';
  seven := '0.7';
  one := '1';
  two := '2';
  i := 1;
  fa := one;
  x := BigDecimal.Abs(xi);
  ax := x;
  if ax = one then begin                              // 1/2 90
    ans := pib / two;
    goto EXT;
  end;
  if ax > seven then begin                            // 0.7𒴂cošvZ
    x := one - x * x;
    x := x.RoundToPrecision(dpcs);
    x := BigDecimal.Sqrt(x, dpcs * 2);                // sqrt ͗L1/2
  end;
  fb := two;
  ta := fa;
  tb := fb;
  ab := '3';
  d := x * x * x;
  d := d.RoundToPrecision(dpcs);
  ans := (x + d * (ta / tb / ab));
  repeat
    bans := ans;
    d := d * x * x;
    d := d.RoundToPrecision(dpcs);
    fa := fa + two;
    fb := fb + two;
    ab := ab + two;
    ta := ta * fa;
    ta := ta.RoundToPrecision(dpcs);
    tb := tb * fb;
    tb := tb.RoundToPrecision(dpcs);
    f := (ta / tb / ab) * d;
    ans := ans + f;
    inc(i);
  until (bans = ans) or (i > 10000);
  if ax > seven then ans := pib / two - ans;
EXT:
  ans := ans.RoundToPrecision(pcsBack);
  if xi < zero then ans := -ans;
  result := ans;
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arcsin(z)
// J[\̑ȉ~ϕ RCɂ
function arcsin_big(z: bigdecimal): bigdecimal;
var
  zero, one, two, xi, eight, pib, sq: Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  eight := '0.8';
  z := z.RoundToPrecision(dpcs);
  zero := '0';
  one := '1';
  two := '2';
  pib := Pi_big / two;
  if BigDecimal.Abs(z) < eight then begin
    xi := one - z * z;
    xi := xi.RoundToPrecision(dpcs);
    result := z * Rc(xi, one);
  end
  else begin
    xi := z * z;
    xi := xi.RoundToPrecision(dpcs);
    result := RC(xi, one);
    sq := one - xi;
    sq := Bigdecimal.Sqrt(sq, dpcs * 2);
    result := sq * result;
    result := pib - result;
    if z < zero then result := -result;
  end;
  result := result.RoundToPrecision(pcsBack);
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arccos(x)
// 0.7𒴂甽Α̊px߂܂(arcsinvZɂȂ܂)
// arccos(x) = /2 - arcsin(x)
function arccosa_big(xi: bigdecimal): bigdecimal;
label
  EXT;
var
  i : integer;
  pib, ans, bans, fa, fb, d, ab, ta, tb, f, x, seven, zero, one, two, ax: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  xi := xi.RoundToPrecision(dpcs);
  zero := '0';
  seven := '0.7';
  two := '2';
  one := '1';
  i := 1;
  fa := '1';
  x := BigDecimal.Abs(xi);
  ax := x;
  if ax = zero then begin                             // [/2 90
    ans := pib / two;
    goto EXT;
  end;
  if ax > seven then begin                            // 0.7𒴂cošvZ
    x := one - x * x;
    x := x.RoundToPrecision(dpcs);
    x := BigDecimal.Sqrt(x, dpcs * 2);                // sqrt ͗L1/2
  end;
  fb := '2';
  ta := fa;
  tb := fb;
  ab := '3';
  d := x * x * x;
  d := d.RoundToPrecision(dpcs);
  ans := (x + d * (ta / tb / ab));
  repeat
    bans := ans;
    d := d * x * x;
    d := d.RoundToPrecision(dpcs);
    fa := fa + 2;
    fb := fb + 2;
    ab := ab + 2;
    ta := ta * fa;
    ta := ta.RoundToPrecision(dpcs);
    tb := tb * fb;
    tb := tb.RoundToPrecision(dpcs);
    f := (ta / tb / ab) * d;
    ans := ans + f;
    inc(i);
  until (bans = ans) or (i > 10000);
  if ax <= seven then ans := pib / two - ans;
EXT:
  if xi < zero then ans := pib - ans;
  ans := ans.RoundToPrecision(pcsBack);
  result := ans;
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arccos(z)
// J[\̑ȉ~ϕ RCɂ
function arccos_big(z: bigdecimal): bigdecimal;
var
  v, t, e, one, two, zero, z1, pib: Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  z := z.RoundToPrecision(dpcs);
  zero := '0';
  z1 := '0.1';
  one := '1';
  two := '2';
  if bigdecimal.Abs(z) > z1 then begin
    v := z * z;
    v := v.RoundToPrecision(dpcs);
    t := Rc(v, one);
    e := BigDecimal.Sqrt(one - v, dpcs * 2);            // sqrt ͗L1/2
    result := e * t;
  end
  else begin
    v := one - z * z;
    v := v.RoundToPrecision(dpcs);
    result := bigdecimal.Abs(z) * Rc(v, one);
    result := pib / two - result;
  end;
  if z < zero then result := pib - result;
  result := result.RoundToPrecision(pcsBack);
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arctanf
// 1 z甽Α̊pxvZ
// IngEIC[̌vZ
function arctana_bigf(xi, pib: bigdecimal; dpcs: integer): bigdecimal;
var
  i : integer;
  x, ax, y, ans, bans, f, ib, zero, one, two, a2: bigdecimal;
begin
  xi := xi.RoundToPrecision(dpcs);
  x := bigdecimal.Abs(xi);
  ax := x;
  zero := '0';
  one := '1';
  two := '2';
  if x > one then ax := one / x;
  a2 := ax * ax;
  a2 := a2.RoundToPrecision(dpcs);
  y := a2 / (one + a2);
//  y := y.RoundToScale(dpcs, rmNearesteven);
  i := 0;
  ib := one;
  ans := one;
  f := one;
  repeat
    bans := ans;
    f := f * ib * (two / (ib * two + one)) * y;
    f := f.RoundToPrecision(dpcs);
    ans := ans  + f;
    ans := ans.RoundToPrecision(dpcs);
    ib := ib + one;
    inc(i);
  until (bans = ans) or (i > 10000);
  if ax <> zero then ans := ans * (y / ax)
                else ans := zero;
  if x > one then ans := pib / two - ans;
  if xi < zero then ans := -ans;

  result := ans;
end;

// arctan
function arctana_big(xi: bigdecimal): bigdecimal;
var
  pib: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  result := arctana_bigf(xi, pib, dpcs);                   // IngEIC[̌vZ

  result := result.RoundToPrecision(pcsBack);
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arctanf(z)
// J[\̑ȉ~ϕ RCɂ
// 1 z甽Α̊pxvZ
function arctan_bigf(z, pib: bigdecimal; dpcs: integer): bigdecimal;
var
  v, t, one, two, za: Bigdecimal;
  fr : integer;
begin
  z := z.RoundToPrecision(dpcs);
  za := BigDecimal.Abs(z);
  fr := 0;
  one := '1';
  two := '2';
  if za > one then begin
    za := one / za;
    fr := 1;
  end;
  v := (one + za * za);
  v := v.RoundToPrecision(dpcs);
  t := Rc(one, v);
  result := za * t;
  if fr = 1 then result := pib / two - result;
  if z < 0 then result := -result;
end;

// arctan(z)
function arctan_big(z: bigdecimal): bigdecimal;
var
  pib: bigdecimal;
  pcsBack, dpcs: integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  result := arctan_bigf(z, pib, dpcs);                     // J[\̑ȉ~ϕ RCɂ

//  result := result.RoundToScale(pcsback, rmNearesteven);
  result := result.RoundToPrecision(pcsBack);

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arctan2
// x=0,y=0 ̏ꍇ`Ȃ0Ԃ܂B
// IngEIC[̌vZ
function arctan2a_big(yi, xi: bigdecimal): bigdecimal;
label
  EXT;
var
  x, y, ans, zero, two, pib: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  xi := xi.RoundToPrecision(dpcs);
  yi := yi.RoundToPrecision(dpcs);
  zero := '0';
  two := '2';
  if xi = zero then begin
    if yi = zero then ans := zero;                    // l 荇 0
    if yi > zero then ans := pib / two;
    if yi < zero then ans := -pib / two;
    goto EXT;
  end;
  if yi = zero then begin
    if xi > zero then ans := zero;
    if xi < zero then ans := pib;
    goto EXT;
  end;
  x := bigdecimal.Abs(xi);
  y := bigdecimal.Abs(yi);
  x := y / x;

  ans := arctana_bigf(x, pib, dpcs);                    // tan IngEIC[̌vZ

  if (yi > zero) and (xi < zero) then ans := pib - ans;
  if (yi < zero) and (xi < zero) then ans := ans - pib;
  if (yi < zero) and (xi > zero) then ans := -ans;
EXT:
//  ans := ans.RoundToScale(pcsback, rmNearesteven);
  ans := ans.RoundToPrecision(pcsBack);
  result := ans;
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arctan2
// J[\RCɂvZ
// x=0,y=0 ̏ꍇ`Ȃ0Ԃ܂B
function arctan2_big(yi, xi: bigdecimal): bigdecimal;
label
  EXT;
var
  x, y, ans, zero, two, pib: bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pib := pi_big;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  xi := xi.RoundToPrecision(dpcs);
  yi := yi.RoundToPrecision(dpcs);
  zero := '0';
  two := '2';
  if xi = zero then begin
    if yi = zero then ans := zero;                    // l 荇 0
    if yi > zero then ans := pib / two;
    if yi < zero then ans := -pib / two;
    goto EXT;
  end;
  if yi = zero then begin
    if xi > zero then ans := zero;
    if xi < zero then ans := pib;
    goto EXT;
  end;
  x := bigdecimal.Abs(xi);
  y := bigdecimal.Abs(yi);
  x := y / x;

  ans := arctan_bigf(x, pib, dpcs);                   // J[\RCɂvZ

  if (yi > zero) and (xi < zero) then ans := pib - ans;
  if (yi < zero) and (xi < zero) then ans := ans - pib;
  if (yi < zero) and (xi > zero) then ans := -ans;

EXT:
//  ans := ans.RoundToScale(pcsback, rmNearesteven);
  ans := ans.RoundToPrecision(pcsBack);
  result := ans;

  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arsinh(z)
// J[\̑ȉ~ϕ RCɂ
function arsinh_big(z: bigdecimal): bigdecimal;
var
  one, xi: Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  z := z.RoundToPrecision(dpcs);
  one := '1';
  xi := one + z * z;
  xi := xi.RoundToPrecision(dpcs);
  result := z * Rc(xi, one);
  result := result.RoundToPrecision(pcsBack);
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// arcosh(z)
// J[\̑ȉ~ϕ RCɂ
function arcosh_big(z: bigdecimal): bigdecimal;
label
  EXT;
var
  v, t, e, one: Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  z := z.RoundToPrecision(dpcs);
  one := '1';
  if z <= one then begin
    application.MessageBox('P傫ĉB','',0);
    result := '0';
    goto EXT;
  end;
  v := z * z;
  v := v.RoundToPrecision(dpcs);
  t := Rc(v, one);
  e := BigDecimal.Sqrt(v - one, dpcs * 2);            // sqrt ͗L1/2
  result := e * t;
  result := result.RoundToPrecision(pcsBack);
EXT:
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// artanh(z)
// J[\̑ȉ~ϕ RCɂ
function artanh_big(z: bigdecimal): bigdecimal;
label
  EXT;
var
  v, t, one, two: Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  z := z.RoundToPrecision(dpcs);
  one := '1';
  if z >= one then begin
    application.MessageBox('P菬ĉB','',0);
    result := '0';
    goto EXT;
  end;
  two := '2';
  v := (one - z * z);
  v := v.RoundToPrecision(dpcs);
  t := Rc(one, v);
  result := z * t;
  result := result.RoundToPrecision(pcsBack);
EXT:
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// ln(x)
// J[\̑ȉ~ϕ RCɂ
// ܂傫Ȓl͕s  1e62x
// Ȓl1e-26
function log_biga(xi: bigdecimal): bigdecimal;
var
  v, t, e, one, two: Bigdecimal;
  dpcs : integer;
begin
  dpcs := BigDecimal.DefaultPrecision;                // w萸x
  xi := xi.RoundToPrecision(dpcs);
  one := '1';
  two := '2';
  v := (xi + one) / two;
  v := v * v;
  v := v.RoundToPrecision(dpcs);
  t := Rc(v, xi);
  e := xi - one;
  result := t * e;
  result := result.RoundToPrecision(dpcs);
end;

// x = m * 2^n n̒l2^n̒l߂܂
// result = n
// ta     = 2^n
// m = x / 2^n
function frexpa(x: bigdecimal; var ta: biginteger): integer;
var
  tb: biginteger;
  xi, one: bigdecimal;
  n, j, s, pcs : integer;
begin
  pcs := BigDecimal.DefaultPrecision;
  one := '1';
  one := one.RoundToPrecision(pcs);
  xi := x;
  if xi < one then x := one / x;
  ta := 1;
  n := 0;
  if x < ta then begin
    result := n;
    exit;
  end;
  j := 0;
  ta := '1';
  s := 4096;             // s=4^i    i = 6
  repeat
    while x > ta do begin
      biginteger.ShiftLeft(ta, s, tb);
      ta := tb;
      inc(j);
    end;
    if (s > 1) and (j > 0) then begin
      dec(j);
      biginteger.Shiftright(ta, s, tb);
      ta := tb;
    end;
    n := n + s * j;
    j := 0;
    s := s div 4;
  until s = 0;
  if xi < one then begin
    n := -n + 1;
    biginteger.Shiftright(ta, 1, tb);
    ta := tb;
  end;
  result := n                             // ta = 2^n
end;

// loge(x)    ln(x)
// WJ
// 1e}500000 xx
// FL True  L␳ False L␳
function log_bigf(xi: bigdecimal; FL: boolean): bigdecimal;
label
  EXT;
const
  KK = 10000;
var
  LOG2, SQRT2, two, last, s, one, one1, x2, i, k2: bigdecimal;
  k : integer;
  kb, ta : biginteger;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  result := '0';
  if xi <= result then begin
    application.MessageBox('ȒlłB','',0);
    exit;
  end;
  s := '1e-5';
  last := '1e10';
  pcsBack := BigDecimal.DefaultPrecision;               // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;             // Zۂ߃[hobNAbv
  dpcs := pcsBack;
  one := '1';
  if xi = one then begin
//    result := '0';                                  // ݒς
    goto EXT;
  end;
  if (xi > s) and (xi < last) then begin                // w̒lꍇRCvZ
    if FL then begin
      dpcs := pcsBack + 5;                              // w萸x + 
      BigDecimal.DefaultPrecision := dpcs;
      BigDecimal.DefaultRoundingMode := rmNearesteven;
    end;
    result := log_biga(xi);                             // RCvZ
    goto EXT;
  end;
  one1 := '1e500000';
  if xi < one then begin
    last := one / xi;
    if last > one1 then begin
      application.MessageBox('l܂B','',0);
      goto EXT;
    end;
  end;
  if xi > one1 then begin
    application.MessageBox('l傫܂B','',0);
    goto EXT;
  end;
  if FL then begin
    dpcs := pcsBack + 5;                              // w萸x + 
    BigDecimal.DefaultPrecision := dpcs;
    BigDecimal.DefaultRoundingMode := rmNearesteven;
  end;
  one1 := one.RoundToPrecision(dpcs);
  two := '2';
  LOG2 := log_biga(two);                              // log(2)
  SQRT2 := bigdecimal.Sqrt(two, dpcs * 2);
  k := frexpa(xi / SQRT2, ta);                        // x / 2 = m * 2^k  ta = 2^k
  kb := k;
  if k < 0 then begin                                 // k
//    k := -k;                                          // ]
    k2 := ta;                                         // 2^k  intege to decimal
    k2 := k2.RoundToPrecision(dpcs);
    k2 := one1 / k2;                                  // 1/(2^k) = 2^-k
  end
  else
    k2 := ta;                                         // 2^k  intege to decimal
  k2 := k2.RoundToPrecision(dpcs);
  xi := xi / k2;                                      // x / 2^k
//  Main.Form1.Memo1.Lines.Append('x=' + xi.ToPlainString);
  xi := (xi - one) / (xi + one);
  x2 := xi * xi;
  x2 := x2.RoundToPrecision(dpcs);
  i := one;
  s := xi;
  k := 0;                                             // [vEop
  repeat
    xi := xi * x2;
    xi := xi.RoundToPrecision(dpcs);
    i := i + two;
    last := s;
    s := s + xi / i;
    s := s.RoundToPrecision(dpcs);
    inc(k);
  until (last = s) or (k > KK);
  result := LOG2 * kb + two * s;
  if k > KK then begin
    application.MessageBox('ZG[B','',0);
    result := '0';
  end;
EXT:
  result := result.RoundToPrecision(pcsBack);
  if FL then begin
    BigDecimal.DefaultPrecision := pcsBack;           // ZZxA
    BigDecimal.DefaultRoundingMode := rmBack;         // Zۂ߃[hA
  end;
end;

// log(x)
function log_big(xi: bigdecimal): bigdecimal;
begin
  result := log_bigf(xi, True);
end;

// sub e^x
function expb(x: Bigdecimal; k: bigInteger): Bigdecimal;
var
  w : bigdecimal;
  izero, ione, km : bigInteger;
  dpcs : integer;
begin
  dpcs := BigDecimal.DefaultPrecision;
  izero := '0';
  ione := '1';
  if k >= izero then w := '2'
           else begin
             w := '0.5';
             k := -k;
           end;
  while k <> izero do begin
    if k and ione = ione then begin
      x := x * w;
      x := x.RoundToPrecision(dpcs);
    end;
    w := w * w;
    w := w.RoundToPrecision(dpcs);
    bigInteger.ShiftRight(k, 1, km);
    k := km;
  end;
  result := x;
end;

// e^x
function expa(x: bigdecimal): bigdecimal;
var
  neg, dpcs : integer;
  km, a, e, prev, LOG2, zero, one, two : bigdecimal;
  k, i, ione: bigInteger;
begin
  dpcs := BigDecimal.DefaultPrecision;
  zero := '0';
  one := '1';
  two := '2';
  LOG2 := log_big(two);                   // log(2)
  km := (x / LOG2);
  km := km.Floor;
  k := km.AsBigInteger;
  x := x - k * LOG2;
  x := x.RoundToPrecision(dpcs);
  if x >= zero then neg := 0              // tO 0
               else begin
                      neg := 1;           // tO 1
                      x := -x;
                    end;
  e := one + x;
  a := x;
  i := '2';
  ione := '1';
  repeat
    prev := e;
    a := a * (x / i);
    a := a.RoundToPrecision(dpcs);
    e := e + a;
    e := e.RoundToPrecision(dpcs);
    i := i + ione;
  until e = prev;
  if neg <> 0 then e := one / e;          // Ȃt
  result := expb(e, k);
end;

// e^x
function exp_big(x: bigDecimal): bigdecimal;
var
  d : bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  d := '100000000';
  if x > d then begin
    result := '0';
    application.MessageBox('l傫܂B','',0);
    exit;
  end;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;

  x := x.RoundToPrecision(dpcs);
  result := expa(x);
  result := result.RoundToPrecision(pcsBack);
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// power(x, y)  x^y   e^(log(x) * y)
function power_big(xi, yi: bigdecimal): bigdecimal;
label
  EXT;
var
  t, lx : Bigdecimal;
  d : Bigdecimal;
  pcsBack, dpcs : integer;
  rmback : BigDecimal.RoundingMode;
begin
  result := '0';
  if xi < result then begin
    application.MessageBox('ȒlłB','',0);
    exit;
  end;
  pcsBack := BigDecimal.DefaultPrecision;             // ZZxobNAbv
  rmBack := BigDecimal.DefaultRoundingMode;           // Zۂ߃[hobNAbv
  dpcs := pcsBack + 5;                                // w萸x + 
  BigDecimal.DefaultPrecision := dpcs;
  BigDecimal.DefaultRoundingMode := rmNearesteven;
  xi := xi.RoundToPrecision(dpcs);
  yi := yi.RoundToPrecision(dpcs);
  // log(x)
  t := log_bigf(xi, False);
  lx := t * yi;
  lx := lx.RoundToPrecision(dpcs);
  d := '100000000';
  if BigDecimal.abs(lx) > d then begin
    result := '0';
    application.MessageBox('l傫܂B','',0);
    goto EXT;
  end;
  // e^x
  result := expa(lx);
  result := result.RoundToPrecision(pcsBack);
EXT:
  BigDecimal.DefaultPrecision := pcsBack;             // ZZxA
  BigDecimal.DefaultRoundingMode := rmBack;           // Zۂ߃[hA
end;

// Bigdecimal -> Double
function BigdecimalToDouble(b: bigdecimal): double;
const
  maxdouble = 1.7976931348623158E308;     // 1.7976931348623'2'E308 -> INF
  mindouble = 4.94065645841247E-324;
var
  bigstr : string;
  absb : bigdecimal;
begin
  absb := bigdecimal.Abs(b);
  if absb = bigdecimal.Zero then begin
    result := 0;
    exit;
  end;
  if absb >= maxdouble then begin
    result := maxdouble;
    if b < bigdecimal.Zero then result := -result;
    exit;
  end;
  if absb <= mindouble then begin
    result := mindouble;
    if b < bigdecimal.Zero then result := -result;
    exit;
  end;
  b := b.RoundToPrecision(30);
  bigstr := b.ToString;
  result := strtofloat(bigstr);
end;

end.
